REM http://www.gpsbabel.org/download.html#downloading

set OSGEO4W_ROOT=C:\OSGeo4W64
set P=gpsbabel
set V=1.4.4
set B=1

set R=..\..\..\release\%P%
if not exist %R%\%P%fe mkdir %R%\%P%fe
copy setup.hint %R%\setup.hint
copy fe.hint %R%\%P%fe\setup.hint
copy ..\COPYING %R%\%P%-%V%-%B%.txt
copy ..\COPYING %R%\%P%fe\%P%fe-%V%-%B%.txt

set pf=%ProgramFiles(x86)%
if "%pf%"=="" set pf=%ProgramFiles%
path %SYSTEMROOT%\system32;%SYSTEMROOT%;%SYSTEMROOT%\System32\Wbem;%pf%\CMake 2.8\bin
call "%pf%\Microsoft Visual Studio 10.0\VC\vcvarsall.bat" x64
path %pf%\Microsoft Visual Studio 10.0\Common7\IDE;%PATH%
set OLDPATH=%PATH%
call "%OSGEO4W_ROOT%\bin\o4w_env.bat"
path %OLDPATH%;%OSGEO4W_ROOT%\bin;c:\cygwin\bin
echo on

copy CMakeLists.txt ..
copy fe-CMakeLists.txt ..\gui\CMakeLists.txt
copy mainwindow.cpp ..\gui

if not exist build mkdir build
rm -rf install
mkdir install
set INSTDIR=%CD%\install
cd build

set LIB=%LIB%;%OSGEO4W_ROOT%\lib
set INCLUDE=%INCLUDE%;%OSGEO4W_ROOT%\include

set BUILDCONF=RelWithDebInfo

cmake -G "Visual Studio 10 Win64" ^
	-DCMAKE_CONFIGURATION_TYPES=%BUILDCONF% ^
	-DCMAKE_INSTALL_PREFIX=%INSTDIR% ^
	-DSETUPAPI_LIBRARY="%PROGRAMFILES(X86)%/Microsoft SDKs/Windows/v7.0A/Lib/x64/SetupAPI.Lib" ^
        ..\..
if errorlevel 1 goto error

for %%i in (ZERO_CHECK ALL_BUILD INSTALL) do (
	echo %%i: %DATE% %TIME%
	devenv %P%.sln /Project %%i /Build %BUILDCONF%
	if errorlevel 1 (echo %%i error & goto error)
)

cd ..

if not exist install\etc\postinstall mkdir install\etc\postinstall
if not exist install\etc\preremove mkdir install\etc\preremove
copy gpsbabelfe.bat.tmpl install\bin
copy fe-postinstall.bat install\etc\postinstall\%P%fe.bat
copy fe-preremove.bat install\etc\preremove\%P%fe.bat
if not exist install\apps\%P%\help mkdir install\apps\%P%\help
copy ..\gui\gmapbase.html install\apps\%P%\help
copy qt.conf.tmpl install\apps\%P%

tar -C %INSTDIR% -cvjf %R%\%P%-%V%-%B%.tar.bz2 bin/gpsbabel.exe
if errorlevel 1 goto error

tar -C %INSTDIR% -cvjf %R%\%P%fe\%P%fe-%V%-%B%.tar.bz2 ^
	--exclude bin/gpsbabel.exe apps bin etc
if errorlevel 1 goto error

tar -C .. -cvjf %R%\%P%-%V%-%B%-src.tar.bz2 ^
	osgeo4w/CMakeLists.txt ^
	osgeo4w/fe-CMakeLists.txt ^
	osgeo4w/config.h ^
	osgeo4w/fe.hint ^
	osgeo4w/fe-postinstall.bat ^
	osgeo4w/fe-preremove.bat ^
	osgeo4w/gpsbabelfe.bat.tmpl ^
	osgeo4w/package.cmd ^
	osgeo4w/setup.hint
if errorlevel 1 goto error

:error
